
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x, y;
let v = 0;
let f = 1;
let fr=1;
let av = 4;
let dv = av;
let r = 20;
let buffer = null;
let d = { width: canvas.width, height: canvas.height };

function init() {
    d = { width: canvas.width, height: canvas.height };
    v = 0;
    f = 1;
	fr=1;
    av = 4;
    dv = av;
    r = 20;
    buffer = createBuffer(d.width, d.height);
    drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
    const g = buffer.getContext("2d");
    g.fillStyle = "white";
    g.fillRect(0, 30, d.width, d.height - 30);
    g.strokeStyle = "black";
    g.beginPath();
    g.moveTo(120 , 30);
    g.lineTo(120  , d.height);
    g.moveTo(0, d.height / 4  );
    g.lineTo(d.width, d.height / 4 );
    g.stroke();

    for (x = 0; x <= d.width; x = x + r) {
        y = -(d.height / 8) * Math.sin((x - v) * 2 * Math.PI / 360) + d.height / 4;
        g.fillStyle = (x === 120) ? "red" : "blue";
        g.beginPath();
        g.arc(x, y, r / 2, 0, Math.PI * 2);
        g.fill();
    }

    for (x = 0; x <= d.width; x = x + 2 * r) {
        y = 40 * Math.sin((x - v) * 2 * Math.PI / 360) + x ;
        g.fillStyle = (x === 120) ? "red" : "blue";
        g.fillRect(y, d.height * 3 / 4 - 3 * r, r / 2, 7 * r);
    }
}

function move() {
    dv =fr* f * av;
    v = v + dv;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
}

document.getElementById('dirx').addEventListener('click', dirx);
document.getElementById('dirxx').addEventListener('click', dirxx);
document.getElementById('sph').addEventListener('click', sph);
document.getElementById('spl').addEventListener('click', spl);
//document.getElementById('reset').addEventListener('click', reset);
document.getElementById('scaleS').addEventListener('click', scaleS);
document.getElementById('scaleL').addEventListener('click', scaleL);
document.getElementById('stop').addEventListener('click', stop);
document.getElementById('staart').addEventListener('click', staart);


function dirx() {
        f=1;
}
function dirxx() {
        f=-1;
}
function sph() {
        av=4;
}
function spl() {
        av=2;
}
function stop() {
        fr=0;
}
function staart() {
        fr=1;
}
function scaleS() {
        r=10;
}
function scaleL() {
        r=20;
}
/*
function changeParameter(label) {
    switch (label) {
        case "+x":
            f = 1;
            break;
        case "-x":
            f = -1;
            break;
        case "high":
            av = 10;
            break;
        case "low":
            av = 5;
            break;
        case "stop":
            av = 0;
            break;
        case "S":
            r = 10;
            break;
        case "L":
            r = 20;
            break;
        default:
            break;
    }
}

canvas.addEventListener("click", function(event) {
    const targetLabel = event.target.getAttribute("label");
    if (targetLabel) {
        changeParameter(targetLabel);
    }
});   */

init();
start();




